/*
Copyright 2018 New Vector Ltd
Copyright 2019 The Matrix.org Foundation C.I.C.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import { encodeUnpaddedBase64Url } from "./base64";
import { crypto } from "./crypto/crypto";
var LOWERCASE = "abcdefghijklmnopqrstuvwxyz";
var UPPERCASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
var DIGITS = "0123456789";
export function secureRandomBase64Url(len) {
  var key = new Uint8Array(len);
  crypto.getRandomValues(key);
  return encodeUnpaddedBase64Url(key);
}
export function randomString(len) {
  return randomStringFrom(len, UPPERCASE + LOWERCASE + DIGITS);
}
export function randomLowercaseString(len) {
  return randomStringFrom(len, LOWERCASE);
}
export function randomUppercaseString(len) {
  return randomStringFrom(len, UPPERCASE);
}
function randomStringFrom(len, chars) {
  var ret = "";
  for (var i = 0; i < len; ++i) {
    ret += chars.charAt(Math.floor(Math.random() * chars.length));
  }
  return ret;
}
//# sourceMappingURL=randomstring.js.map